<script>
import inputBlock from './InputBlock.vue';
import tabModeInputBlock from './TabModeInputBlock.vue';

export default {
    components: {
    inputBlock,
    tabModeInputBlock
    },
    /******************************
     * The form generator takes as props :
     *  - formID : id of the form html tag
     *  - formItemsList : the list of objects that represent eavh input of the form (they are formated, each type of input has its own keys and information necessary to describe it)
     *  - formValues : the json gathering all values entered by the user
     *  - tabMode : boolean that tells if the generator generates a tabMode form or a creation/correction form
     ******************************/
    props: {
        'formID': String,
        'formItemsList': Object,
        'formValues': { type: Object, default: {} },
        'tabMode': Boolean
    },
    /******************************
     * We emit the values that the user entered in the form. These values are gathered in a json.
     ******************************/
    emits: ['update:formValues'],
    /******************************
     * The method mounted() is executed once when the component has been mounted on the DOM.
     * Here we make sure that the databases are created with their stores before using them and we initialize some values.
    ******************************/
    mounted() {
        if (this.tabMode) {
            let d = new Date();
            let todayDate = d.toISOString().substring(0, 10);
            document.getElementById('paramStartDateInput').setAttribute('value', todayDate);
            this.formValues.tabModeStartDate = todayDate;
            this.$emit('update:formValues', this.formValues);
        }
    },
}
</script>

<template>

<!-- CREATION OF AN OBJECT FORM -->
    <form v-if="formItemsList && (!tabMode)" :id="formID" method="post">
        <inputBlock v-for="item in formItemsList" :key="'div_'.concat(item['id'])"
        :itemInformations="item"
        :formItemValue="item.parameterValue"
        @update:formItemValue="newValue => {formValues[item['name']] = newValue; $emit('update:formValues', formValues);}" />
    </form>
<!-- --- --- --- --- --- -->


<!-- TABMODE FORM -->
    <form v-if="(formItemsList && tabMode)" :id="formID">
        <p>  </p>
        <div class="row rowSysma requiredParameter">
            <div class="col-md-4 col-xs-4 colonne1">
                <b>Date de l'observation (date de début)</b>
            </div>
            <div class="col-md-4">  
                <input type="date"
                    data-toggle="tooltip"
                    data-placement="right"
                    title=""
                    class="form-control input-sm"
                    id="paramStartDateInput"
                    name="start_date"
                    value=""
                    size="30"
                    onchange="checkDate('paramStartDateInput', 'paramStartDateInputComment', 'paramsSheetSubmitButton', 'end_dateparameterObjet');"
                    required="required"
                    data-original-title="Date de début de la validité de cette value ou bien 0 si elle n'est pas définie"
                    @input="formValues.tabModeStartDate = $event.target.value; $emit('update:formValues', formValues);">
            </div>
            <div class="col-md-4">  
                <div id="paramStartDateInputComment"></div>
            </div>
            <input id="end_dateparameterObjet" name="end_date" value="0" size="30" type="hidden">
        </div>
        <p>  </p>
        <h2>Renseignement de l'objet</h2>
        <tabModeInputBlock v-for="item in formItemsList" :key="'div_'.concat(item['id'])"
            :itemInformations="item"
            :formItemValue="item.parameterValue"
            @update:formItemValue="newValue => {formValues[item['name']] = newValue; $emit('update:formValues', formValues);}"
            @update:formItemOfflineStatus="newValue => {formValues[item['name'].concat('OfflineStatus')] = newValue; $emit('update:formValues', formValues);}" />
    </form>
<!-- --- --- --- --- --- -->

</template>